#pragma once


class CDumpper
{

protected:

	enum
	{
		FACTOR_LEN = 2 + 1,

		LINE_NUM = 16,

		ADD_SP   = 1,   // ' '   Xy[X
		ADD_NULL = 1,	// '\0'  NUL 
	};


	_TCHAR m_szBuffer[(LINE_NUM * FACTOR_LEN + ADD_SP) + (LINE_NUM + ADD_NULL)];

	_TCHAR *const m_lpszHex;

	_TCHAR *const m_lpszChar;


	INT_PTR m_nIndex;


	INT_PTR (CDumpper::* m_lpfnDisplay)( BYTE const* lpBuffer, LARGE_INTEGER* lpRemaningLengt );


public:

	LARGE_INTEGER m_offset;


protected:

	INT_PTR DisplayFirst( BYTE const* lpBuffer, LARGE_INTEGER* lpRemaningLength );

	INT_PTR DisplayNext( BYTE const* lpBuffer, LARGE_INTEGER* lpRemaningLength );

	
	inline INT_PTR HexChar( INT_PTR nValue );


	void SetHexChar( INT_PTR nIndex, INT_PTR nValue );

	BOOL IsEmptyRemaning( INT_PTR nCount, LARGE_INTEGER* lpRemaningLength );


public:

	CDumpper();

	void BeginDisplay();

	INT_PTR Display( BYTE const* lpBuffer, LARGE_INTEGER length );
};


inline INT_PTR CDumpper::HexChar( INT_PTR nValue )
{
	nValue &= 0x0f;

	return ( nValue < 0x0a ? _T('0') : _T('a') - 0x0a ) + nValue;
}
